'use strict';

module.exports = {
    prop: prop => obj => obj[prop],

    filter (obj, pred) {
        return Object.keys(obj).reduce((filtered, key) => {
            const value = obj[key];

            if (pred(key, value)) {
                filtered[key] = value;
            }

            return filtered;
        }, {});
    },

    defaults (obj, values) {
        Object.keys(values).forEach(key => {
            if (!obj.hasOwnProperty(key)) {
                obj[key] = values[key];
            }
        });
    }
};